diff --git a/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py b/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
index 3a7ee58..028ee64 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/roles/tests/utils.py
@@ -152,3 +152,38 @@ def delete_role(connection, role_names):
         exception = "Error while deleting role: %s: line:%s %s" % (
             file_name, sys.exc_traceback.tb_lineno, exception)
         print(exception, file=sys.stderr)
+
+
+def create_role_with_password(server, role_name, role_password):
+    """
+     This function create the role.
+     :param server:
+     :param role_name:
+     :param role_password:
+     :return:
+     """
+    try:
+        connection = utils.get_db_connection(server['db'],
+                                             server['username'],
+                                             server['db_password'],
+                                             server['host'],
+                                             server['port'],
+                                             server['sslmode'])
+        pg_cursor = connection.cursor()
+        pg_cursor.execute(
+            "CREATE ROLE %s LOGIN PASSWORD '%s'" % (role_name, role_password))
+        connection.commit()
+        # Get 'oid' from newly created tablespace
+        pg_cursor.execute(
+            "SELECT pr.oid from pg_catalog.pg_roles pr WHERE pr.rolname='%s'" %
+            role_name)
+        oid = pg_cursor.fetchone()
+        role_id = ''
+        if oid:
+            role_id = oid[0]
+        connection.close()
+        return role_id
+    except Exception as exception:
+        exception = "Error while deleting role: %s: line:%s %s" % (
+            file_name, sys.exc_traceback.tb_lineno, exception)
+        print(exception, file=sys.stderr)
diff --git a/web/pgadmin/model/__init__.py b/web/pgadmin/model/__init__.py
index 425c9e6..1d30092 100644
--- a/web/pgadmin/model/__init__.py
+++ b/web/pgadmin/model/__init__.py
@@ -94,6 +94,15 @@ class ServerGroup(db.Model):
     name = db.Column(db.String(128), nullable=False)
     __table_args__ = (db.UniqueConstraint('user_id', 'name'),)
 
+    @property
+    def serialize(self):
+        """Return object data in easily serializable format"""
+        return {
+            'id': self.id,
+            'user_id': self.user_id,
+            'name': self.name,
+        }
+
 
 class Server(db.Model):
     """Define a registered Postgres server"""
@@ -175,6 +184,44 @@ class Server(db.Model):
     tunnel_password = db.Column(db.String(64), nullable=True)
     shared = db.Column(db.Boolean(), nullable=False)
 
+    @property
+    def serialize(self):
+        """Return object data in easily serializable format"""
+        return {
+            "id": self.id,
+            "user_id": self.user_id,
+            "servergroup_id": self.servergroup_id,
+            "name": self.name,
+            "host": self.host,
+            "hostaddr": self.hostaddr,
+            "port": self.port,
+            "maintenance_db": self.maintenance_db,
+            "username": self.username,
+            "password": self.password,
+            "save_password": self.save_password,
+            "role": self.role,
+            "ssl_mode": self.ssl_mode,
+            "comment": self.comment,
+            "discovery_id": self.discovery_id,
+            "db_res": self.db_res,
+            "passfile": self.passfile,
+            "sslcert": self.sslcert,
+            "sslkey": self.sslkey,
+            "sslrootcert": self.sslrootcert,
+            "sslcrl": self.sslcrl,
+            "sslcompression": self.sslcompression,
+            "bgcolor": self.bgcolor,
+            "fgcolor": self.fgcolor,
+            "service": self.service,
+            "connect_timeout": self.connect_timeout,
+            "use_ssh_tunnel": self.use_ssh_tunnel,
+            "tunnel_host": self.tunnel_host,
+            "tunnel_port": self.tunnel_port,
+            "tunnel_authentication": self.tunnel_authentication,
+            "tunnel_identity_file": self.tunnel_identity_file,
+            "tunnel_password": self.tunnel_password
+        }
+
 
 class ModulePreference(db.Model):
     """Define a preferences table for any modules."""
diff --git a/web/pgadmin/static/js/sqleditor/new_connection_dialog.js b/web/pgadmin/static/js/sqleditor/new_connection_dialog.js
new file mode 100644
index 0000000..dc1c064
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/new_connection_dialog.js
@@ -0,0 +1,262 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2020, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import $ from 'jquery';
+import Alertify from 'pgadmin.alertifyjs';
+import pgAdmin from 'sources/pgadmin';
+import Backform from 'pgadmin.backform';
+import newConnectionDialogModel from 'sources/sqleditor/new_connection_dialog_model';
+
+
+let NewConnectionDialog = {
+  'dialog': function(handler, reconnect) {
+    let url = url_for('sqleditor.get_new_connection_data', {
+      'sid': handler.url_params.sid,
+      'sgid': handler.url_params.sgid,
+    });
+
+    if(reconnect) {
+      url += '?connect=1';
+    }
+
+    let title = gettext('Connect to server');
+
+    $.ajax({
+      url: url,
+      headers: {
+        'Cache-Control' : 'no-cache',
+      },
+    }).done(function (res) {
+      let response = res.data.result;
+      response.database_list = [];
+      response.user_list = [];
+      if (Alertify.newConnectionDialog) {
+        delete Alertify.newConnectionDialog;
+      }
+
+      // Create Dialog
+      Alertify.dialog('newConnectionDialog', function factory() {
+        let $container = $('<div class=\'new-connection-dialog\'></div>');
+        return {
+          main: function(message) {
+            this.msg = message;
+          },
+          build: function() {
+            this.elements.content.appendChild($container.get(0));
+            Alertify.pgDialogBuild.apply(this);
+          },
+          setup: function(){
+            return {
+              buttons: [
+                {
+                  text: '',
+                  key: 112,
+                  className: 'btn btn-primary-icon pull-left fa fa-question pg-alertify-icon-button',
+                  attrs: {
+                    name: 'dialog_help',
+                    type: 'button',
+                    label: gettext('Help'),
+                    'aria-label': gettext('Help'),
+                    url: url_for('help.static', {
+                      'filename': 'query_tool.html',
+                    }),
+                  },
+                },
+                {
+                  text: gettext('Cancel'),
+                  key: 27,
+                  className: 'btn btn-secondary fa fa-times pg-alertify-button',
+                  'data-btn-name': 'cancel',
+                }, {
+                  text: gettext('OK'),
+                  key: 13,
+                  className: 'btn btn-primary fa fa-check pg-alertify-button',
+                  'data-btn-name': 'ok',
+                },
+              ],
+              // Set options for dialog
+              options: {
+                title: title,
+                //disable both padding and overflow control.
+                padding: !1,
+                overflow: !1,
+                model: 0,
+                resizable: true,
+                maximizable: false,
+                pinnable: false,
+                closableByDimmer: false,
+                modal: false,
+                autoReset: false,
+                closable: true,
+              },
+            };
+          },
+          prepare: function() {
+            let self = this;
+            $container.html('');
+            // Disable Ok button
+            this.__internal.buttons[2].element.disabled = true;
+
+            // Status bar
+            this.statusBar = $(
+              '<div class=\'pg-prop-status-bar pg-el-xs-12 d-none\'>' +
+            '  <div class="error-in-footer"> ' +
+            '    <div class="d-flex px-2 py-1"> ' +
+            '      <div class="pr-2"> ' +
+            '        <i class="fa fa-exclamation-triangle text-danger" aria-hidden="true"></i> ' +
+            '      </div> ' +
+            '      <div class="alert-text" role="alert"></div> ' +
+            '    </div> ' +
+            '  </div> ' +
+            '</div>').appendTo($container);
+
+            // To show progress on filter Saving/Updating on AJAX
+            this.showNewConnectionProgress = $(
+              `<div id="show_filter_progress" class="pg-sp-container sql-editor-busy-fetching d-none">
+                <div class="pg-sp-content">
+                    <div class="row"><div class="col-12 pg-sp-icon sql-editor-busy-icon"></div></div>
+                    <div class="row"><div class="col-12 pg-sp-text sql-editor-busy-text">` + gettext('Loading data...') + `</div></div>
+                </div>
+            </div>`
+            ).appendTo($container);
+            $(
+              self.showNewConnectionProgress[0]
+            ).removeClass('d-none');
+
+            self.newConnCollectionModel = newConnectionDialogModel(response, handler.url_params.sgid, handler.url_params.sid);
+            let fields = Backform.generateViewSchema(null, self.newConnCollectionModel, 'create', null, null, true);
+
+            let view = this.view = new Backform.Dialog({
+              el: '<div></div>',
+              model: self.newConnCollectionModel,
+              schema: fields,
+            });
+
+            $(this.elements.body.childNodes[0]).addClass(
+              'alertify_tools_dialog_properties obj_properties'
+            );
+
+            $container.append(view.render().$el);
+
+            // Enable/disable save button and show/hide statusbar based on session
+            view.listenTo(view.model, 'pgadmin-session:start', function() {
+              view.listenTo(view.model, 'pgadmin-session:invalid', function(msg) {
+                self.statusBar.removeClass('d-none');
+                $(self.statusBar.find('.alert-text')).html(msg);
+                // Disable Okay button
+                self.__internal.buttons[2].element.disabled = true;
+              });
+
+              view.listenTo(view.model, 'pgadmin-session:valid', function() {
+                self.statusBar.addClass('d-none');
+                $(self.statusBar.find('.alert-text')).html('');
+                // Enable Okay button
+                self.__internal.buttons[2].element.disabled = false;
+              });
+            });
+
+            view.listenTo(view.model, 'pgadmin-session:stop', function() {
+              view.stopListening(view.model, 'pgadmin-session:invalid');
+              view.stopListening(view.model, 'pgadmin-session:valid');
+            });
+
+            // Starts monitoring changes to model
+            view.model.startNewSession();
+
+            // Hide Progress ...
+            $(
+              self.showNewConnectionProgress[0]
+            ).addClass('d-none');
+          },
+          callback: function(e) {
+            let self = this;
+            if (e.button.element.name == 'dialog_help') {
+              e.cancel = true;
+              pgAdmin.Browser.showHelp(e.button.element.name, e.button.element.getAttribute('url'),
+                null, null);
+              return;
+            } else if (e.button['data-btn-name'] === 'ok') {
+              e.cancel = true; // Do not close dialog
+              let newConnCollectionModel = this.newConnCollectionModel.toJSON();
+
+              let selected_database_name = null;
+              response.database_list.forEach(function(data){
+                if(newConnCollectionModel['database'] == data['value']) {
+                  selected_database_name = data['label'];
+                  return false;
+                }
+              });
+              let title = '';
+              if(newConnCollectionModel['role']) {
+                title = selected_database_name + '/' + newConnCollectionModel['role'] + '@' + response.server_name;
+              } else {
+                title = selected_database_name + '/' + newConnCollectionModel['user'] + '@' + response.server_name;
+                newConnCollectionModel['role'] = null;
+              }
+
+              let is_create_connection = true;
+
+              handler.gridView.connection_list.forEach(function(connection_data){
+                if(parseInt(connection_data['server']) == newConnCollectionModel['server']
+                && parseInt(connection_data['database']) == newConnCollectionModel['database']
+                && connection_data['user'] == newConnCollectionModel['user'] && connection_data['role'] == newConnCollectionModel['role']) {
+                  is_create_connection = false;
+                  // break for loop by return false.
+                  return false;
+                }
+
+                if(title == connection_data['title']) {
+                  is_create_connection = false;
+                  return false;
+                }
+              });
+              if(!is_create_connection) {
+                let errmsg = 'Connection with this configuration already present.';
+                Alertify.info(errmsg);
+              }else {
+                let connection_details = {
+                  'server_group': handler.gridView.handler.url_params.sgid,
+                  'server': newConnCollectionModel['server'],
+                  'database': newConnCollectionModel['database'],
+                  'title': title,
+                  'user': newConnCollectionModel['user'],
+                  'role': newConnCollectionModel['role'],
+                  'password': response.password,
+                };
+                handler.gridView.on_change_connection(connection_details, self);
+              }
+            } else {
+              self.close();
+            }
+          },
+        };
+      });
+      setTimeout(function(){
+        Alertify.newConnectionDialog('Connect to server.').resizeTo(pgAdmin.Browser.stdW.md,pgAdmin.Browser.stdH.md);
+      }, 500);
+    }).fail(function(error) {
+      Alertify.alert().setting({
+        'title': gettext('Connection lost'),
+        'label':gettext('Ok'),
+        'message': gettext('Connection to the server has been lost.'),
+        'onok': function(){
+          alert(error);
+          //Close the window after connection is lost
+          window.close();
+        },
+      }).show();
+    });
+
+  },
+
+};
+
+module.exports = NewConnectionDialog;
diff --git a/web/pgadmin/static/js/sqleditor/new_connection_dialog_model.js b/web/pgadmin/static/js/sqleditor/new_connection_dialog_model.js
new file mode 100644
index 0000000..1cba6e6
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/new_connection_dialog_model.js
@@ -0,0 +1,339 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2020, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+import _ from 'underscore';
+import $ from 'jquery';
+import pgAdmin from 'sources/pgadmin';
+import Backform from 'pgadmin.backform';
+import url_for from 'sources/url_for';
+import alertify from 'pgadmin.alertifyjs';
+
+export default function newConnectionDialogModel(response, sgid, sid) {
+
+  let server_name = '';
+  let database_name = '';
+
+  let NewConnectionSelect2Control = Backform.Select2Control.extend({
+    fetchData: function(){
+      let self = this;
+      url = self.field.get('url');
+
+      let url = url_for(url, {
+        'sid': self.model.attributes.server,
+        'sgid': sgid,
+      });
+
+      $.ajax({
+        async: false,
+        url: url,
+        headers: {
+          'Cache-Control' : 'no-cache',
+        },
+      }).done(function (res) {
+        var transform = self.field.get('transform');
+        if(res.data.status){
+          let data = res.data.result.data;
+
+          if (transform && _.isFunction(transform)) {
+            self.field.set('options', transform.bind(self, data));
+          } else {
+            self.field.set('options', data);
+          }
+        } else {
+          if (transform && _.isFunction(transform)) {
+            self.field.set('options', transform.bind(self, []));
+          } else {
+            self.field.set('options', []);
+          }
+          //alertify.error(res.data.msg);
+        }
+      }).fail(function(e){
+        let msg = '';
+        if(e.status == 404) {
+          msg = 'Unable to find url.';
+        } else {
+          msg = e.responseJSON.errormsg;
+        }
+        alertify.error(msg);
+      });
+    },
+    render: function() {
+      this.fetchData();
+      return Backform.Select2Control.prototype.render.apply(this, arguments);
+    },
+    onChange: function() {
+      Backform.Select2Control.prototype.onChange.apply(this, arguments);
+    },
+  });
+
+  let newConnectionModel = pgAdmin.Browser.DataModel.extend({
+    idAttribute: 'name',
+    defaults: {
+      server: parseInt(sid),
+      database: null,
+      user: null,
+      password: null,
+      server_name: server_name,
+      database_name: database_name,
+    },
+    schema: [{
+      id: 'server',
+      name: 'server',
+      label: gettext('Server'),
+      type: 'text',
+      editable: true,
+      disabled: false,
+      select2: {
+        allowClear: false,
+      },
+      control: Backform.Select2Control.extend({
+        connect: function(self) {
+          /*if (alertify.connectServer) {
+            delete alertify.connectServer;
+          }*/
+          if(!alertify.connectServer){
+            alertify.dialog('connectServer', function factory() {
+              return {
+                main: function(
+                  title, message, sid, submit_password=true
+                ) {
+                  this.set('title', title);
+                  this.message = message;
+                  this.server_id = sid;
+                  this.submit_password = submit_password;
+                },
+                setup:function() {
+                  return {
+                    buttons:[{
+                      text: gettext('Cancel'), className: 'btn btn-secondary fa fa-times pg-alertify-button',
+                      key: 27,
+                    },{
+                      text: gettext('OK'), key: 13, className: 'btn btn-primary fa fa-check pg-alertify-button',
+                    }],
+                    focus: {element: '#password', select: true},
+                    options: {
+                      modal: 0, resizable: false, maximizable: false, pinnable: false,
+                    },
+                  };
+                },
+                build:function() {
+                },
+                prepare:function() {
+                  this.setContent(this.message);
+                },
+                callback: function(closeEvent) {
+
+                  if (closeEvent.button.text == gettext('OK')) {
+                    if(this.submit_password) {
+                      var _url = url_for('schema_diff.connect_server', {'sid': this.server_id});
+
+                      $.ajax({
+                        type: 'POST',
+                        timeout: 30000,
+                        url: _url,
+                        data: $('#frmPassword').serialize(),
+                      })
+                        .done(function() {
+                          self.model.attributes.database = null;
+                          self.model.attributes.user = null;
+                          self.model.attributes.role = null;
+                          Backform.Select2Control.prototype.onChange.apply(self, arguments);
+                          response.server_list.forEach(function(obj){
+                            if(obj.id==self.model.changed.server) {
+                              response.server_name = obj.name;
+                            }
+                          });
+                        })
+                        .fail(function(xhr) {
+                          alertify.connectServer('Connect to server', xhr.responseJSON.result, self.getValueFromDOM());
+                        });
+                    } else {
+                      response.password = $('#password').val();
+                    }
+                  } else {
+                    self.model.attributes.database = null;
+                    self.model.attributes.user = null;
+                    self.model.attributes.role = null;
+                    Backform.Select2Control.prototype.onChange.apply(self, arguments);
+                  }
+                  closeEvent.close = true;
+                },
+              };
+            });
+          }
+        },
+        render: function() {
+          let self = this;
+          self.connect(self);
+          return Backform.Select2Control.prototype.render.apply(self, arguments);
+        },
+        onChange: function() {
+          this.model.attributes.database = null;
+          this.model.attributes.user = null;
+          let self = this;
+          self.connect(self);
+
+          let url = url_for('sqleditor.connect_server', {
+            'sid': self.getValueFromDOM(),
+          });
+          $.ajax({
+            async: false,
+            url: url,
+            headers: {
+              'Cache-Control' : 'no-cache',
+            },
+          }).done(function () {
+            Backform.Select2Control.prototype.onChange.apply(self, arguments);
+            response.server_list.forEach(function(obj){
+              if(obj.id==self.model.changed.server) {
+                response.server_name = obj.name;
+              }
+            });
+          }).fail(function(xhr){
+            alertify.connectServer('Connect to server', xhr.responseJSON.result, self.getValueFromDOM());
+          });
+
+        },
+      }),
+      options: function() {
+        return _.map(response.server_list, (obj) => {
+          if (obj.id == parseInt(sid))
+            response.server_name = obj.name;
+
+          return {
+            value: obj.id,
+            label: obj.name,
+          };
+        });
+      },
+    },
+    {
+      id: 'database',
+      name: 'database',
+      label: gettext('Database'),
+      type: 'text',
+      editable: true,
+      disabled: function(m) {
+        let self_local = this;
+        if (!_.isUndefined(m.get('server')) && !_.isNull(m.get('server'))
+            && m.get('server') !== '') {
+          setTimeout(function() {
+            if(self_local.options.length) {
+              m.set('database', self_local.options[0].value);
+            }
+          }, 10);
+          return false;
+        }
+
+        return true;
+      },
+      deps: ['server'],
+      url: 'sqleditor.get_new_connection_database',
+      select2: {
+        allowClear: false,
+        width: '100%',
+        first_empty: true,
+        select_first: false,
+      },
+      extraClasses:['new-connection-dialog-style'],
+      control: NewConnectionSelect2Control,
+      transform: function(data) {
+        response.database_list = data;
+        return data;
+      },
+    },
+    {
+      id: 'user',
+      name: 'user',
+      label: gettext('User'),
+      type: 'text',
+      editable: true,
+      deps: ['server'],
+      select2: {
+        allowClear: false,
+        width: '100%',
+      },
+      control: NewConnectionSelect2Control,
+      url: 'sqleditor.get_new_connection_user',
+      disabled: function(m) {
+        let self_local = this;
+        if (!_.isUndefined(m.get('server')) && !_.isNull(m.get('server'))
+            && m.get('server') !== '') {
+          setTimeout(function() {
+            if(self_local.options.length) {
+              m.set('user', self_local.options[0].value);
+            }
+          }, 10);
+          return false;
+        }
+        return true;
+      },
+    },{
+      id: 'role',
+      name: 'role',
+      label: gettext('Role'),
+      type: 'text',
+      editable: true,
+      deps: ['server'],
+      select2: {
+        allowClear: false,
+        width: '100%',
+        first_empty: true,
+      },
+      control: NewConnectionSelect2Control,
+      url: 'sqleditor.get_new_connection_role',
+      disabled: false,
+    },
+    /*{
+      id: 'password',
+      name: 'password',
+      label: gettext('Password'tools/sqleditor/__init__.py),
+      type: 'password',
+      editable: true,
+      disabled: true,
+      deps: ['user'],
+      control: Backform.InputControl.extend({
+        render: function() {
+          let self = this;
+          self.model.attributes.password = null;
+          Backform.InputControl.prototype.render.apply(self, arguments);
+          return self;
+        },
+        onChange: function() {
+          let self = this;
+          Backform.InputControl.prototype.onChange.apply(self, arguments);
+        },
+      }),
+    },*/
+    ],
+    validate: function() {
+      let msg = null;
+      this.errorModel.clear();
+      if(_.isUndefined(this.get('database')) || _.isNull(this.get('database'))){
+        msg = gettext('Please select database');
+        this.errorModel.set('database', msg);
+        return msg;
+      } else if(_.isUndefined(this.get('database')) || _.isUndefined(this.get('user'))|| _.isNull(this.get('user'))) {
+        msg = gettext('Please select user');
+        this.errorModel.set('user', msg);
+        return msg;
+      }
+      /*else if((this.attributes.password == '' || _.isUndefined(this.get('password')) || _.isNull(this.get('password')))) {
+        msg = gettext('Please enter password');
+        this.errorModel.set('password', msg);
+        return msg;
+      }*/
+      return null;
+    },
+  });
+
+  let model = new newConnectionModel();
+  return model;
+}
